#include <bits/stdc++.h>

using namespace std;
#define MAXN 505
#define INF 100000000
typedef pair<int,int> pii;
int n,m;
int mat[MAXN][MAXN];
int dx[]={0,-1,-1,-1,0,1,1,1};
int dy[]={-1,-1,0,1,1,1,0,-1};
//prvo je samo levo
int dist[MAXN][MAXN][5][8];
//0-kralj,1-lovac,2-top,3-konj,4-kraljica

bool nemoguce(int koji,int kretanje)
{
	if(koji == 1 && kretanje % 2 != 1)return true;
	if(koji == 2 && kretanje % 2 != 0)return true;
	return false;
}

void bfs(int x,int y)
{
	queue <pii> q;
	for(int i = 0; i <= n; i++)for(int j = 0; j <= m; j++)for(int k = 0; k < 5; k++)for(int l = 0; l < 8; l++)dist[i][j][k][l]=INF;
	dist[x][y][0][0]=0;
	q.push({x*MAXN+y,0*MAXN+0});
	while(!q.empty())
	{
		pii p = q.front();
		q.pop();
		int x = p.first/MAXN;
		int y = p.first%MAXN;
		if(!mat[x][y])continue;
		int koji = p.second/MAXN;
		int kretanje = p.second%MAXN;
		for(int zkoji = 0; zkoji < 5; zkoji++)
		{
			for(int zkretanje = 0; zkretanje < 8; zkretanje++)
			{
				if(nemoguce(zkoji,zkretanje))continue;
				int xx;
				int yy;
				xx = x+dx[zkretanje];
				yy = y+dy[zkretanje];
				if(zkoji == 3)
				{
					if(zkretanje == 0)xx=x-1,yy=y-2;
					if(zkretanje == 1)xx=x-2,yy=y-1;
					if(zkretanje == 2)xx=x-2,yy=y+1;
					if(zkretanje == 3)xx=x-1,yy=y+2;
					if(zkretanje == 4)xx=x+1,yy=y+2;
					if(zkretanje == 5)xx=x+2,yy=y+1;
					if(zkretanje == 6)xx=x+2,yy=y-1;
					if(zkretanje == 7)xx=x+1,yy=y-2;
				}
				if(!mat[xx][yy])continue;
				int eps;
				if(zkoji == koji && zkretanje == kretanje && koji!=0 && koji!=3)eps = 0;
				else
				{
					if(zkoji != koji)eps = zkoji+1+1;
					else eps = 1;
				}
				if(dist[xx][yy][zkoji][zkretanje] > dist[x][y][koji][kretanje]+eps)
				{
					dist[xx][yy][zkoji][zkretanje] = dist[x][y][koji][kretanje]+eps;
					q.push({xx*MAXN+yy,zkoji*MAXN+zkretanje});
				}
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin >> n >> m;
	for(int i = 1; i <= n; i++)
	{
		for(int j = 1; j <= m; j++)
		{
			char c;
			cin >> c;
			if(c=='#')
			{
				mat[i][j]=0;
			}
			else mat[i][j]=1;
		}
	}
	bfs(1,1);
	int ans = INF;
	for(int i = 0; i < 5; i++)for(int j = 0; j < 8; j++)ans=min(ans,dist[n][m][i][j]);
	if(ans==INF)cout << -1;
	else cout << ans;
	return 0;
}